'use strict';
const sqlite3 = require('sqlite3');
const sqlite = require('sqlite');
const path = require('node:path');

let db;

(async () => {
  db = await sqlite.open({ filename: path.resolve('data/users.db'),
                           driver: sqlite3.Database
  });
  console.log('connected to users.db');
})();

class DBOps {
  async insertUser(user) {
    let result;
    try {
      result = await db.run('insert into Users(Uid, Name, AuthCert, UserCert) values(?, ?, ?, ?)',
       [user.Uid, user.Name, user.AuthCert, user.UserCert]);
      if (result.changes === 0)
        result.lastID = 0;
    }
    catch (err) {
      result = err;
    }
    return result;
  }

  async getUserByUid(uid) {
    let result;
    try {
      result = await db.get("select * from Users where Uid=?", [uid]);    // one object with the selected fields
      if (result == null)
        result = {};
    }
    catch (err) {
      result = err;
    }
    return result;
  }
}

module.exports = new DBOps();